{
Copyright (c) 2010, Carl-Philip Hänsch

Permission to use, copy, modify, and/or distribute this software for any purpose with or
without fee is hereby granted, provided that the above copyright notice and this permission
notice appear in all copies.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS
SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL
THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY
DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
OR PERFORMANCE OF THIS SOFTWARE.
}


{
	* Diese API hilft dem GLES-Entwickler, 
	* kleinere Programme mit weniger Aufwand zu schreiben.
	* Man bekommt Hilfsfunktionen, um Shader zu kompilieren
	* und den Shaderlog im Pascal-String-Format zu erhalten.
	* 
	* }
unit gles_shaderapi;
{$mode objfpc}{$H+}

interface
uses gles_header;

function glesutGetInfoLog(shader: cardinal): string;
function glesutGetProgInfoLog(prog: cardinal): string;
function glesutLoadShader(source: string; typ: cardinal): cardinal;
function glesutCreateProgram(vertex, fragment: cardinal): cardinal;

implementation

function glesutCreateProgram(vertex, fragment: cardinal): cardinal;
begin
	result:=glCreateProgram(); // Programm erstellen
	glAttachShader(result, vertex); // Vertex-Shader anhängen
	glAttachShader(result, fragment); // Fragment-Shader anhängen
	glLinkProgram (result); // Beides linken
end;

function glesutLoadShader(source: string; typ: cardinal): cardinal;
var i: integer;
    p: pointer;
begin
	result:=glCreateShader(typ);
  p:=@source[1]; i:=length(source);
	glShaderSource(result, 1, @p, @i);
	glCompileShader(result);
end;

function glesutGetInfoLog(shader: cardinal): string;
var i: integer;
begin
	glGetShaderiv(shader, GL_INFO_LOG_LENGTH, @i);
	setlength(result, i);
	if i<>0 then begin
		glGetShaderInfoLog(shader, i, nil, @result[1]);
	end;
end;

function glesutGetProgInfoLog(prog: cardinal): string;
var i: integer;
begin
	glGetShaderiv(prog, GL_INFO_LOG_LENGTH, @i);
	setlength(result, i);
	if i<>0 then begin
		glGetProgramInfoLog(prog, i, nil, @result[1]);
	end;
end;


end.
